/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
#ifndef __HBBOX_H__
#define __HBBOX_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HPoint.h"

#define FMAX 1e10

class HBBox
{
public:
	HVector3D a,b;

	HBBox() : a(FMAX,FMAX,FMAX), b(-FMAX,-FMAX,-FMAX) {}
	HBBox(HVector3D _a,HVector3D _b) : a(_a), b(_b) {}

	bool IsEmpty()
	{
		//return a.x>=FMAX || a.y>=FMAX || a.z>=FMAX
		//    || b.x<=FMAX || b.y<=FMAX || b.z<=FMAX;
		return (a.x>b.x || a.y>b.y || a.z>b.z);
	}

	void Clear()
	{
		a.x= FMAX; a.y= FMAX; a.z= FMAX;
		b.x=-FMAX; b.y=-FMAX; b.z=-FMAX;
	}
	HBBox &operator +=(const HBBox &p)
	{
		if (p.a.x<a.x) a.x=p.a.x;
		if (p.a.y<a.y) a.y=p.a.y;
		if (p.a.z<a.z) a.z=p.a.z;
		if (p.b.x>b.x) b.x=p.b.x;
		if (p.b.y>b.y) b.y=p.b.y;
		if (p.b.z>b.z) b.z=p.b.z;
		return *this;
	}
	HBBox operator +(const HBBox &p)
	{
		return HBBox(HVector3D(min(a.x,p.a.x)
		                          ,min(a.y,p.a.y)
															,min(a.z,p.a.z))
									,HVector3D(max(b.x,p.b.x)
									            ,max(b.y,p.b.y)
															,max(b.z,p.b.z))
									);
	}
	float Size()
	{
		if (IsEmpty()) return 0;
		HVector3D v=b-a;
		return v.Length();
	}

  bool in(const HPoint3D &p)
  {
    return (  p.x>=a.x && p.x<=b.x
                && p.y>=a.y && p.y<=b.y
                && p.z>=a.z && p.z<=b.z);
  }

	void Aff();
};

#endif
