/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
#ifndef __HMISSILE_H__
#define __HMISSILE_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HPoint.h"
#include "HBBox.h"
#include "HObject.h"
#include "HTank.h"
#include "HParticule.h"

class HMissile
{
//protected:
public:

	static HObject obj;
  static HBBox bb;

	static HPoint3D Grav;

public:
	static HBBox bbClip;

	static HPartSyst * psys;

	static bool bFog;
	static bool bExplodeFire;
	static bool bExplodeFog;

public:

	static bool Load();
	static bool LoadTexture();

	static void SetGravity(float g=10.0f);

	static void SetArena(HBBox *bb);

	static void SetPartSyst(HPartSyst *ps);

//protected:
public:

	HPoint3D Pos;// tank pos
	HPoint3D Vit;

	HTank *source; // tank number

	HMissile *next; // next missile in chain

public:

	HMissile(HTank *tank,float speed=1.0f);

	void Aff(); // render missile

	void Update(float t,float dt);

	void Explode(bool impact); // add particules for explosion (impact=on a tank?)

	HMissile *Next()
	{
		return next;
	}

	void SetNext(HMissile *m)
	{
		next=m;
	}

	void DeleteNext();

	HMissile *DeleteThis();

};

#endif
