/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
#ifndef __HPARTICULE_H__
#define __HPARTICULE_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HPoint.h"
#include "HObject.h"
#include "HTank.h"
#include "RTexture.h"

class HParticule
{
protected:

	static RTexture txt;

public:

	enum {
		TFlare=0,
		TExplo=1,
		T2=2,
		T3=3,
		T4=4,
		T5=5,
		T6=6,
		T7=7,
		TFog=8,
		NFog=8,
		NPTYPE=16
	};

protected:

	static HTexCoord2f tcPart[NPTYPE][2];

	static HPoint3D Grav;

public:
	static HBBox bbClip;

	//static HPoint3D aff_dx,aff_dy;
	static HPoint3D aff_dp[4];

public:

	static bool Load();
	static bool LoadTexture();

	static void SetGravity(float g=10.0f);

	static void SetArena(HBBox *bb);

//protected:
public:

	HPoint3D Pos; // tank pos
	HPoint3D Vit;

	float m;

	int type;

	float size,ds;

	HColor4f c;

	float da; // dalpha/dt

	float time; // time to death

public:

	HParticule();

	void Clear();

	static void Aff0(const HPoint3D &dx,const HPoint3D &dy); // init rendering

	void Aff(); // render

	static void AffEnd();

	void Update(float t,float dt);

};

class HPartSyst // Particule System
{
//protected:
public:

	int npmax,np;
	HParticule *tp;

public:

	HPartSyst();
	~HPartSyst();

	void Alloc(int nbp=1000);

	void Free();

	void Aff(const HPoint3D &dx,const HPoint3D &dy);

	void Update(float t,float dt);

	HParticule *AddParticule();

};

#endif
