/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
#ifndef __HSCENE_H__
#define __HSCENE_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HObject.h"
#include "HBBox.h"
#include "HTank.h"
#include "HMissile.h"
#include "HParticule.h"
#include "HTankAI.h"

#ifdef __HSCENE__
#define SCENE_API 
#else
#define SCENE_API extern
#endif

//SCENE_API HObject oTank;
//SCENE_API HObject oTankTurret;
//SCENE_API HObject oTankGun;

#define NTANK 8

//SCENE_API HObject oSol;
//SCENE_API HBBox   bbSol;
SCENE_API HObject oArena;
SCENE_API HBBox   bbArena;
SCENE_API HObject oSky;

SCENE_API HTank TTank[NTANK];
SCENE_API HTankAI * TTankAI[NTANK];
SCENE_API HTank *PlayerTank;

SCENE_API HMissile *lMissiles
#ifdef __HSCENE__
=NULL
#endif
;

SCENE_API HPartSyst PartSyst;

SCENE_API void NewMissile(HTank *tank=PlayerTank, float speed=100.0f);

SCENE_API void UpdateMissile(float t,float dt);

SCENE_API void ResolveCollisions(); // resolve tank collisions

SCENE_API void AffMissile();

SCENE_API void FreeMissile();


#endif
