/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
// RImage.cpp: implementation of the RImage class.
//
//////////////////////////////////////////////////////////////////////

#include "Std.h"
#include "RImage.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RImage::RImage()
{
  m_nBPP = 0;
  m_nWidth = m_nHeight = m_nStride = 0;
  m_nData = 0;
  m_pData = 0;
}

RImage::~RImage()
{
  Toast();
}

// Create using an image loader.
// Usage:   myTexture.Create( "Nifty.bmp", imgLoadBMP );
bool RImage::Create( char *szImageName, fncImageLoader imgLoader)
{
  return imgLoader( szImageName, this );
}

// Create using basic parameters to allocate an image buffer.
// Usage:   myImage.Create( 128, 256, 24 );  // Creates a 128x256x24bpp image.
bool RImage::Create( UInt32 width, UInt32 height, UInt32 bpp )
{
  Toast(); // Nuke any old image data.

  if( width==0 || height==0 || bpp==0 )
    return false;

  m_nWidth = width;
  m_nStride = width * ((bpp+7)/8);
  m_nHeight = height;
  m_nBPP = bpp;

  m_nData = m_nStride * m_nHeight;
  m_pData = new BYTE[m_nData];
  if( m_pData == 0 )
    return false;

  return true;
}


void RImage::Toast()
{
  if( m_pData )
  {
		delete [] (BYTE *) m_pData;
    m_pData = 0;
    m_nData = 0;
    m_nBPP = 0;
    m_nWidth = m_nHeight = m_nStride = 0;
  }
}
