/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
// RImage.h: interface for the RImage class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RIMAGE_H__A66B9427_EFBA_11D3_837B_00A0C9DE7E0E__INCLUDED_)
#define AFX_RIMAGE_H__A66B9427_EFBA_11D3_837B_00A0C9DE7E0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class RImage;
typedef bool (*fncImageLoader)(char* szImageName, RImage *img);

class RImage
{
public:
	RImage();
	virtual ~RImage();

  // Create using an image loader.
  // Usage:   myTexture.Create( "Nifty.bmp", imgLoadBMP );
  bool Create( char *szImageName, fncImageLoader imgLoader);

  // Create using basic parameters to allocate an image buffer.
  // Usage:   myImage.Create( 128, 256, 24 );  // Creates a 128x256x24bpp image.
  bool Create( UInt32 width, UInt32 height, UInt32 bpp );
  virtual void Toast();

  int     GetBPP()    {return m_nBPP;}    // Bits per pixel. Valid types are 8(intensity), 24(RGB), 32(RGBA)
  UInt32  GetWidth()  {return m_nWidth;}  // Width of image.
  UInt32  GetStride() {return m_nStride;} // Number of bytes in each horizontal scan line.
  UInt32  GetHeight() {return m_nHeight;} // Height of image.

  UInt32  GetImageSize() {return m_nData;}// Allocated pixel data space used by image.
  void*   GetData()   {return m_pData;}   // Get a pointer to the pixel data.

protected:
  int     m_nBPP;
  UInt32  m_nWidth, m_nHeight, m_nStride;
  UInt32  m_nData;
  void*   m_pData;
};

#endif // !defined(AFX_RIMAGE_H__A66B9427_EFBA_11D3_837B_00A0C9DE7E0E__INCLUDED_)
