/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
//-------------------------------------------------------------------
//	File:		  Texture.h
//	Created:	05/26/99 2:30:AM
//	Author:		Aaron Hilton
//	Comments:	Create and manage OpenGL textures.
//-------------------------------------------------------------------
#ifndef __Texture_h_
#define __Texture_h_

#include "RImage.h"

#include <Kernel/GL/vjGlContextData.h>

class RTextID
{
 public:

  RTextID(unsigned int i=0) : id(i) {}

  operator unsigned int() { return id; }
  unsigned int& operator =(unsigned int i) { return (id=i); }
  unsigned int operator +(unsigned int i) { return id+i; }
  unsigned int operator -(unsigned int i) { return id-i; }
  unsigned int& operator =(int i) { return (id=i); }
  int operator +(int i) { return id+i; }
  int operator -(int i) { return id-i; }
  unsigned int operator ++() { return (++id); }
  unsigned int operator --() { return (--id); }

 protected:
  unsigned int id;
};

class RTexture
{
public:
  RTexture();
  ~RTexture();

  // Create our texture with an image loader.
  // Usage:   myTexture.Create( "Nifty.bmp", imgLoadBMP );
  bool Create( char *szImageName, fncImageLoader imgLoader);
  
  // Create an OpenGL Texture, with our Image class, for input.
  // When using pAlpha, it must be 8bits and pImage must be 24bits.
  // Usage:   myTexture.Create( myImage );
  // or:      myTexture.Create( myImage, my8bitAlphaMap );
  bool Create(RImage *pImage, RImage *pAlpha=0);
  void Toast();
  
  void Use();
  
  bool Usable() { return (*m_nID)!=0; }
  
 protected:
  //unsigned int m_nID;
  vjGlContextData<RTextID> m_nID;
};

#endif // __Texture_h_
//-------------------------------------------------------------------
//	History:
//	$Log: RTexture.h,v $
//	Revision 1.2  2001/03/16 13:04:42  allard
//	Multiple user support added, with dynamic reconfiguration system
//	
//	Revision 1.1.1.1  2001/03/09 13:41:51  allard
//	Hufo OpenGL Tank Game
//	porting to vrjuggler
//	
//-------------------------------------------------------------------
