/******* <my-auto-copyright.pl BEGIN do not edit this line> *******
*								  *
*		    NJ Tank for VR/Net Juggler			  *
*		     Version 1.0  10/12/2002			  *
*-----------------------------------------------------------------*
* COPYRIGHT (C) 2002 Jeremie Allard.        ALL RIGHTS RESERVED.  *
*-----------------------------------------------------------------*
*								  *
*  Original Authors:						  *
*   Jeremie Allard						  *
*								  *
*  Contact: Jeremie.Allard@imag.fr				  *
*           Laboratoire Informatique et Distribution		  *
*           ENSIMAG - antenne de Montbonnot			  *
*           ZIRST 51, avenue Jean Kuntzmann			  *
*           38330 MONTBONNOT SAINT MARTIN			  *
*								  *
*    This program  is free software; you can  redistribute it	  *
*    and/or  modify it  under  the terms  of the GNU  General	  *
*    Public  License  as  published   by  the  Free  Software	  *
*    Foundation;  either  version 2  of the  License,  or any	  *
*    later version.						  *
*								  *
*    This program is distributed in  the hope that it will be	  *
*    useful,  but  WITHOUT  ANY  WARRANTY; without  even  the	  *
*    implied  warranty of  MERCHANTABILITY or  FITNESS  FOR A	  *
*    PARTICULAR PURPOSE.   See the GNU General Public License	  *
*    for more details.						  *
*								  *
*    You  should  have received  a  copy of  the GNU  General	  *
*    Public License along with this library; if not, write to	  *
*    the Free  Software  Foundation,  Inc.,  59 Temple Place,	  *
*    Suite 330, Boston, MA 02111-1307 USA			  *
*								  *
******** <my-auto-copyright.pl END do not edit this line> ********/
//-------------------------------------------------------------------
//	File:		glExt.cpp
//	Created:	10/12/99 19:30:PM
//	Author:		Allard Jeremie
//	Comments:	Find and import OpenGL Extensions.
//-------------------------------------------------------------------
#include "Std.h"
#include "HDef.h"
#include "glExt.h"
#include <stdio.h>
#ifndef _WIN32
# define __USE_GNU
# include <dlfcn.h>
#endif

bool glGetExtension(glExtension *ext)
{
  return r_err;
  if (ext->initok) return r_ok;
  char *strExt=(char*)glGetString(GL_EXTENSIONS);
  bool found=false;
  char *s;
  char *s2;
  //HMsg(strExt);
  s = strExt;
  while( *s )
    {
      s2 = s;
      while( *s2 && *s2 != ' ' ) 
	++s2;
      if (s<s2)
	if( strncmp( s,ext->name, s2-s)==0 )
	  {
	    found=true;
	    break;
	  }
      s=s2+1;
    }
  if (!found)
    {
      return HErrorN(HText("glExtension %s not found",ext->name));
      //return r_err;
    }
#ifndef _WIN32
  //void *h_gl=dlopen("libGL.so",0);
#endif
  int f;
  for (f=0;f<ext->nbfn;++f)
    {
#ifdef _WIN32
      void *proc=wglGetProcAddress(ext->tblfn[f].name);
#else
      void *proc=dlsym(RTLD_DEFAULT,ext->tblfn[f].name);
#endif
      if (!proc) return HErrorN(HText("Fonction %s of extension %s not found",ext->tblfn[f].name,ext->name));
      *ext->tblfn[f].ptr=proc;
    }
  ext->initok=true;
  printf("gl extension %s supported\n",ext->name);
  return r_ok;
}
